 /**
 * Created by Gifer on 13.02.2017.
 */

 var Service    = require('./service.js');
 var console    = require('gifer-console');
 var URL        = require('url');
 var Uploader   = require('./mcUploading').upload;
 var sendIntegrationAPI = require('./mctools/mcIntegrationAPI').sendApiCmdToServer;
 var _purl       = require('./mctools/purl').purl;
 var isAdminSid  = require('./mcconnect').isAdminSid;
 var REST_API    = require('./mctools/mcREST');

 function download (req, res) {
     var file = null;
     var path = null;
     var downloadFile = null;

     try {
         file = URL.parse(req.url).pathname.split('.');
         path = Service.ExtractPath(req.url).split('/');
     } catch (e){ }

     if (file && path){
         if (path.length === 2){
             downloadFile = Service.ExtractFileName(req.url);
         } else {
             downloadFile = path[path.length - 1] + "." + file[file.length - 1];
         }

         Service.sendFiles(req, res, downloadFile, MCPathes.Files);
     } else {
         res.writeHead(404);
         res.end();
     }
 }

 function downloadDB (req, res) {
     var filename = Service.ExtractFileName(req.url);
     var downloadFile = null;
     var purl = _purl(req.url);
     var sid  = purl.param('sid');
     var uin  = purl.param('uin');
     
     if (isAdminSid(sid, uin)){
         try{
             downloadFile = filename.split('?')[0];
         } catch (e){
             console.err('Incorrect file name: ' + filename);
         }

         Service.sendFiles(req, res, downloadFile, MCPathes.Backup);
     } else {
         res.writeHead(404);
         res.end();
     }
 }

 exports.list = {
     "0"  : {
         pathWWW  : '/',
         host 	  : MCServer.Host,
         runFunc  : false,
         cache    : true,
         source	  : MCPathes.WWW + 'lobby/'
     },
     "1"  : {
         pathWWW  : '/chat/',
         host 	  : MCServer.Host,
         redirect : '/chat',
         runFunc  : false,
         cache    : true,
         source	  : MCPathes.WWW
     },
     "3"  : {
         pathWWW  : '/updates/',
         host 	  : MCServer.Host,
         runFunc  : true,
         CallBack : function(req, res) {
             var file = Service.ExtractFileName(req.url);

             Service.sendFiles(req, res, file, MCPathes.Updates);

             console.log('[' + req.remoteHostIp + ', ' + (req.socket && req.socket._parent ? req.socket._parent.connectID : "") + ']: Downloading update file - ' + file);
         }
     },
     "5"  : {
         pathWWW  : '/cmd/',
         ost 	  : MCServer.Host,
         cache    : true,
         source	  : MCPathes.Service
         /*host 	  : MCServer.Host,
         runFunc  : true,
         CallBack : function(req, res) {
             Service.sendFiles(req, res, Service.ExtractFileName(req.url), MCPathes.Service + "/cmd/");
         }*/
     },
     "6"  : {
         pathWWW  : '/admin/',
         host 	  : MCServer.Host,
         redirect : '/admin',
         runFunc  : false,
         cache    : true,
         source	  : MCPathes.WWW
     },
     "7"  : {
         pathWWW  : '/kanban/',
         host 	  : MCServer.Host,
         redirect : '/kanban',
         runFunc  : false,
         cache    : true,
         source	  : MCPathes.WWW
     },
     "8"  : {
         pathWWW  : '/forum/',
         host 	  : MCServer.Host,
         redirect : '/forum',
         runFunc  : false,
         cache    : true,
         source	  : MCPathes.WWW
     },
     "9"  : {
         pathWWW  : '/wallpaper/',
         host 	  : MCServer.Host,
         runFunc  : false,
         cache    : true,
         source	  : MCPathes.WWW
     },
     "11" : {
         pathWWW  : '/downloads/',
         host 	  : MCServer.Host,
         runFunc  : false,
         source	  : function() {
             return MCPathes.ProfilNode;
         }
     },
     "12" : {
         pathWWW  : '/uploads/',
         host 	  : MCServer.Host,
         runFunc  : false,
         source	  : function() {
             return MCPathes.Profile;
         }
     },
     "13" : {
         pathWWW  : '/uploading',
         host 	  : MCServer.Host,
         hasParams: true,
         runFunc  : true,
         CallBack : Uploader
     },
     "14" : {
         pathWWW  : '/moment/',
         host 	  : MCServer.Host,
         cache    : true,
         source	  : MCPathes.NodeModules
     },
     "15" : {
         pathWWW  : '/admin/first.login',
         host 	  : MCServer.Host,
         runFunc  : true,
         CallBack : function(req, res) {
             if (require('./mcconnect').firstLogin()) {
                 res.setHeader("Content-Type", "text/text");
                 res.end('OK');
             } else {
                 res.writeHead(404);
                 res.end();
             }
         },
         source	  : MCPathes.WWW
     },
     "16" : {
         pathWWW  : '/textsource/',
         host 	  : MCServer.Host,
         cache    : true,
         source	  : MCPathes.Service
     },
     "17" : {
         pathWWW  : '/frameworks/',
         host 	  : MCServer.Host,
         cache    : true,
         source	  : MCPathes.Service
     },
     "18" : {
         pathWWW  : '/mctools/',
         host 	  : MCServer.Host,
         cache    : true,
         source	  : MCPathes.Service
     },
    /*
     "20" : {
         pathWWW  : '/vkCode',
         host     : MCServer.Host,
         runFunc  : true,
         CallBack : function(req, res){
             var code = URL.parse(req.url).search;

             VK.auth({
                 client_id     : '',
                 client_secret : "",
                 redirect_uri  : MCServer.Host + "/vkSuccess",
                 code          : code.split('=')[1]
             }, function(err, response, data){
                 if (err){

                 } else {
                     console.log(data);
                 }

                 res.statusCode = 301;
                 res.setHeader('Location', '/');
                 res.end('');
             });
         }
     },
     "21" : {
         pathWWW  : '/vkSuccess',
         host     : MCServer.host,
         runFunc  : true,
         CallBack : function(req, res){

         }
     },
    "22" : {
         pathWWW  : '/painter/',
         host     : MCServer.host,
         runFunc  : false,
         cache    : true,
         source	  : MCPathes.WWW
     },*/
     "23" : {
         pathWWW  : '/serverhelp/',
         host     : MCServer.host,
         redirect : '/serverhelp',
         runFunc  : false,
         cache    : true,
         source	  : MCPathes.WWW
     },
     "24" : {
         pathWWW  : '/API/',
         host     : MCServer.host,
         runFunc  : true,
         source	  : MCPathes.WWW,
         CallBack : sendIntegrationAPI
     },
     /*"25" : {
         pathWWW  : '/testAPI/',
         host     : MCServer.host,
         runFunc  : true,
         source	  : MCPathes.WWW,
         CallBack : function (req, res) {
             var postData   = '';

             function send(postData, res) {
                 console.log(JSON.stringify(postData), console.logLevel.L_Extended);

                 res.end(postData);
             }

             if (req.method === "POST"){
                 var dataLength = req.headers['content-length'];

                 if (dataLength < MCServer.maxUploadData){
                     req.addListener("data", function(postDataChunk) {
                         postData += postDataChunk;

                         if (postData.length > MCServer.maxUploadData){
                             console.err("Too long POST data. Break connection.");

                             req.removeAllListeners();
                             res.end('POST content too large. Access denied.');
                         }
                     });

                     req.addListener("end", function() {
                         send(postData, res);
                     });

                     req.addListener("error", function (e) {
                         console.err(e);
                     })
                 } else {
                     res.end('Access denied. Unknown API version or data length too large');
                 }
             } else
             if (req.method === "GET") {
                 res.end('Access denied. Method not supported');
             }
         }
     }*/

     /*"26"  : {
         pathWWW  : '/medhelp/',
         host 	  : MCServer.Host,
         redirect : '/medhelp',
         runFunc  : false,
         cache    : true,
         source	  : MCPathes.WWW
     },*/
     /*"27"  : {
          pathWWW  : '/hmhCMD.js',
          host 	  : MCServer.Host,
          runFunc  : true,
          CallBack : function(req, res) {
              Service.sendFiles(req, res, Service.ExtractFileName(req.url), MCPathes.Service);
          }
     },
     "28" : {
          pathWWW  : '/textsourcehmh/',
          host 	  : MCServer.Host,
          cache    : true,
          source	  : MCPathes.Service
     }*/
     "29"  : {
         pathWWW  : '/files/',
         host 	  : MCServer.Host,
         cache    : false,
         runFunc  : true,
         CallBack : download
     },
     "30"  : { // alias "files"
         pathWWW  : '/sendimages/',
         host 	  : MCServer.Host,
         cache    : false,
         runFunc  : true,
         CallBack : download
     },
     "31"  : {
         pathWWW  : '/support/',
         host 	  : MCServer.Host,
         redirect : '/support',
         runFunc  : false,
         cache    : true,
         source	  : MCPathes.WWW
     },
     "32"  : {
         pathWWW  : '/support/',
         host 	  : MCServer.Host,
         redirect : '/support.html',
         cache    : false
     },
     "33"  : {
         pathWWW  : '/backupdb/',
         host 	  : MCServer.Host,
         runFunc  : true,
         cache    : false,
         CallBack : downloadDB
     },
     "34"  : {
         pathWWW  : '/rest/',
         host 	  : MCServer.Host,
         runFunc  : true,
         cache    : false,
         CallBack : REST_API
     }
 };

